#pragma rtGlobals=1        // Use modern global access method.

Function CreateDF()   //Create Data Folder
	String savDF= GetDataFolder(1)			// Save current DF for restore.
	NewDataFolder/O/S root:Packages			// Make sure this exists.

	if( DataFolderExists("DirectStepDataAcq") )		// Already created ChristineDataAcq?
		SetDataFolder DirectStepDataAcq					// Our stuff is in here.
	else
		NewDataFolder/S DirectStepDataAcq				// Our stuff goes in here.
		Variable/G RunNum = 0								// Create global variable at runtime.
		String/G orienteering = "nodirection"				// Create global string
		Variable/G running = 0
		Variable/G speed = 0.5
		variable/G l = 0
		variable/G w = 0
		variable/G h = 0
		variable/G f = 0
		variable/G s = 0
		variable/G lfc = 0							// create global variable
	endif
	
	SetDataFolder savDF							// Restore current DF.
End

Function CreatesubDF()   //Create subData Folder
	String savDF= GetDataFolder(1), a, temp			// Save current DF for restore.
	nvar runn=root:packages:DirectStepDataAcq:RunNum
	Variable  test, n
	NewDataFolder/O/S root:Packages:DirectStepDataAcq			// Make sure this exists.
	//NewPath/C DataStorage, C:Users:chelms:Desktop:Test 1:

	n = 1 
	test = 0
	a = num2istr(n)
	
	
	Do
		if( DataFolderExists(("Run"+a)))		// Already created ChristineDataAcq:Run_?
			n = n+1
			a = num2istr(n)
			//SetDataFolder DirectStepDataAcq					// Our stuff is in here.
		else
			temp = "Run"+num2istr(n)
			NewDataFolder/S $(temp)			// Our stuff goes in here.
			Variable/G timer=ticks 			//Create global variable timer that begins when collect data is checked	
			//NewPath/C DataStorage, "C:Users:chelms:Desktop:Test 1:Run"+num2istr(n)
			test = 1							// Create at runtime.
		endif
	while(test < 1)
	
	runn = n 
	MakeRunWave()
	
	//display wave in table
	Edit/K=0 RunWave.ld	
		
	//display wave in graph
	Execute "DataPlot()"
	
		
	SetDataFolder savDF							// Restore current DF.
End


Window DataPlot() : Graph
		//PauseUpdate; Silent 1			// building window...
		String wavelocation
		wavelocation = DataWaveFolder() 		// folder of runwave
		SetDataFolder wavelocation
		Display RunWave[][%'ypostion (um)'] vs RunWave[][%'lateral (V)']
		DoUpdate
EndMacro


Function MakeRunWave()
	Make/N=(1,4) RunWave
		SetDimLabel 1,0,'time (sec)', RunWave
		SetDimLabel 1,1,'xposition (um)', RunWave
		SetDimLabel 1,2,'yposition (um)', RunWave
		SetDimLabel 1,3,'lateral (V)', RunWave
		//SetDimLabel 1,4,'lateral force (N)', RunWave
		DoUpdate 
End	


Function Isitchecked()
	ControlInfo StartDataCollection
	return(V_value)
End

//Function Isitchecked2()
//	ControlInfo RepeatStep
//	return(V_value)
//End
