#pragma rtGlobals=1        // Use modern global access method.

Function/S DataWaveName()  //returns the name of the datawave
	String a
	Variable n
	nvar runn = root:packages:DirectStepDataAcq:RunNum
	
	n = runn
	a = num2istr(n)
		
	Print("root:packages:DirectStepDataAcq:Run"+a+":RunWave")
End

Function/S DataWaveFolder() // returns the name of the datawave folder
	String a
	Variable n
	nvar runn = root:packages:DirectStepDataAcq:RunNum
	
	n = runn
	a = num2istr(n)
		
	Return("root:packages:DirectStepDataAcq:Run"+a)
End

Function DataStorage() //
	String wavelocation, datawave
	String savDF= GetDataFolder(1)
	Variable datacollection, WaveLength, x
	Variable elapsedtime
	Variable voltagex, sensitivityx, positionx
	Variable voltagey, sensitivityy, positiony
	Variable lateral, latforce
	NVar lfc = root:Packages:DirectStepDataAcq:lfc
	
	wavelocation = DataWaveFolder() 		// folder of runwave
	SetDataFolder wavelocation
	
	Wave RunWave
		
	nvar t=$wavelocation+":timer"  	//use timer in the specified run folder
	elapsedtime = (ticks-t)/60
	
	voltagex = Td_ReadValue("input.x") // this reads the position from the x sensor in volts
	sensitivityx = Td_ReadValue("XLVDTSens") //this reads the input sensitivity in m/v
	positionx = voltagex*sensitivityx*1000000 // in micometers 
	
	voltagey = Td_ReadValue("input.y") // this reads the position from the x sensor in volts
	sensitivityy = Td_ReadValue("YLVDTSens") //this reads the input sensitivity in m/v
	positiony = voltagey*sensitivityy*1000000	// in micometers 
	
	lateral = Td_ReadValue("lateral") //this may be normalized by the sum or may not   I believe we want non-normalized value
	
	WaveLength = DimSize(RunWave,0)
	InsertPoints DimSize(RunWave, FindDimLabel(RunWave, 1, "time")), 1, RunWave
	
	PVFastCH(RunWave, "time (sec)", elapsedtime, WaveLength)
	PVFastCH(RunWave, "xposition (um)", positionx, WaveLength)
	PVFastCH(RunWave, "yposition (um)", positiony, WaveLength)
	PVFastCH(RunWave, "lateral (V)", lateral, WaveLength)
	
	
	x = DimSize(RunWave, 0)

	//latforce = (RunWave[x][3] - RunWave[1][3])*lfc
	
	//PVFastCH(RunWave, "lateral force (N)", latforce, Wavelength)
	
	SetDataFolder savDF
	
	//set up the wave to store the data
	// next add data point to the end of the data set
	//InsertPoints 
	
End
	

Function PVFastCH(VarWave,ParmName,Value,Length)
	Wave/Z VarWave
	String ParmName
	Variable Value, Length
	
	Variable ParmTypeIndex, Index
	
	if (!WaveExists(VarWave))
		Debugger
		return(0)
	endif
	 
	Index = Length //this gives the bottom row #
	//Index = FindDimLabel(VarWave,1,ParmName) // need to fix so it references the last populated row +1
	if (Index < 0)
		return(0)
	endif
	ParmTypeIndex = FindDimLabel(VarWave,1,ParmName) //this gives the column number
//	PVSubFunc(VarWave,Index,Value,ParmTypeIndex)
//below this point is really just PVSubFunc pasted in here to be faster.
	VarWave[Index][ParmTypeIndex] = Value
	
End //PVFast
		
	
//Function CreatePath()  // create the path datastorage so that it can be called by FIFOs
//	NewPath/C DataStorage, "C:Users:chelms:Desktop:Test 1:"+date()
//End	

	
  

Display :RunWave[][%'yposition (um)'] vs :packages:DirectStepDataAcq:Run3:RunWave[][%'lateral (V)']