#pragma rtGlobals=1        // Use modern global access method.

Window ControlledStep() : Panel
	PauseUpdate; Silent 1		// building window...
	NewPanel /K=1 /W=(907,464,1228,761)
	SetDrawLayer ProgBack
	SetDrawEnv linethick= 3,linefgc= (39168,13056,0),fillpat= 0
	DrawRect 3,3,318,294
	SetDrawLayer UserBack
			
	CheckBox NudgerXClosedCheck_0,pos={43,63},size={47,14},proc=NudgerCheckFunc,title="X Axis" // x axis Checkbox  if check closed loop LVDT used if not check Xpiezo used
	CheckBox NudgerXClosedCheck_0,help={"Check box to engage LDVT feedback"},value=1
	CheckBox NudgerYClosedCheck_0,pos={119,10},size={47,14},proc=NudgerCheckFunc,title="Y Axis" // Y axis Checkbox
	CheckBox NudgerYClosedCheck_0,help={"Check box to engage LDVT feedback"}, value=1
	CheckBox NudgerZClosedCheck_0,pos={213,9},size={47,14},proc=NudgerCheckFunc,title="Z Axis" // Z axis Checkbox
	CheckBox NudgerZClosedCheck_0,help={"Check box to engage LDVT feedback"}, value=1
	
	Button YUp,pos={134,32},size={30,30},proc=XYStep,title=""  // Y up button
	Button YUp,font="Symbol",fColor=(54272,53248,51200)
	Button YDown,pos={134,77},size={30,30},proc=XYStep,title="" //Y down button
	Button YDown,font="Symbol",fColor=(54272,53248,51200)
	Button XDown,pos={100,55},size={30,30},proc=XYStep,title="" // X left button
	Button XDown,font="Symbol",fColor=(54272,53248,51200)
	Button XUp,pos={168,55},size={30,30},proc=XYStep,title=""  //X right button
	Button XUp,font="Symbol",fColor=(54272,53248,51200)
			
	Button ZUp,pos={228,31},size={30,30},proc=NudgerButtonFunc,title=""
	Button ZUp,font="Symbol",fColor=(54272,53248,51200)
	Button ZDown,pos={228,66},size={30,30},proc=NudgerButtonFunc,title=""
	Button ZDown,font="Symbol",fColor=(54272,53248,51200)
	
	ValDisplay Yposition,pos={243,125},size={60,15},value=Td_ReadValue("input.y")*Td_ReadValue("YLVDTSens")*1000000
	ValDisplay Yposition2,pos={40,125},size={200,10},limits={-45,45,0},barmisc={0,0},value=Td_ReadValue("input.y")*Td_ReadValue("YLVDTSens")*1000000 //position bar

	
	SetVariable NudgerStepSizeSetVar_0,pos={57,165},size={120,18},bodyWidth=80,proc=ARSetVarFunc,title="Step Size" //Step Size SetVars
	SetVariable NudgerStepSizeSetVar_0,font="Arial",fSize=13,format="%.2W1Pm"
	SetVariable NudgerStepSizeSetVar_0,limits={-inf,inf,1e-09},value= root:packages:MFP3D:Main:Variables:ARCustomVariablesWave[%NudgerStepSize]
	
	SetVariable StatusMessage, pos={47,193},size={80,19},fSize=13,frame=0, noedit=1
	SetVariable StatusMessage,value= _STR:"Repeat Step", valueColor=(0,0,0)
	Button StartButton,pos={135,190},size={50,25},proc=StartStopProc,title="Start"
	
	
	SetVariable SecondsBetweenRuns,pos={75,215},size={170,19}, title="Time Between Steps (sec): ", fColor=(32896,32896,32896)
	SetVariable SecondsBetweenRuns,help={"Approximate seconds between runs. Resolution is 1/60th of a second."}
	SetVariable SecondsBetweenRuns,fSize=12,limits={0,5,0.1},value= root:packages:DirectStepDataAcq:speed
	
	CheckBox StartDataCollection,pos={119,265},size={47,14},proc=DataCollection,title="\\f01CollectData",fSize=13 // Collect data button
	CheckBox StartDataCollection,value=0
	
	//SetWindow kwTopWin,hook(AR)=UserCnTPanelHook  //Places nudger in tab
	Execute/Q/Z "DisableButtons(!GV(\"ScanStatus\"))"
	DoUpdate
EndMacro


Function XYStep(CtrlName) //Function for moving in the x-direction to the left
	String CtrlName
	variable test
	nvar running =  root:packages:DirectStepDataAcq:running
	
	if (running == 1)
		StartRepeatedSteps(CtrlName)
	else
	  	SingleStep(CtrlName)
	endif
End
	
	
Function SingleStep(CtrlName)
	String CtrlName
	
	String Direction = CtrlName[0] //take the first letter of the control name which is X Y or Z
	Variable SignValue = StringMatch(CtrlName[1,Strlen(CtrlName)-1],"Up*")*2-1 //if up then SignValue is 1; if down then SignValue is -1
	Variable StepSize = GV("NudgerStepSize") //get the step size from the wave containing that information
	
	CheckNudgerLoops()
		
	Variable IsClosedLoop = GV("Nudger"+Direction+"Closed")  //GetValue nudgerXClosed, returns 0 for NudgerZClosed and returns 1 for X or Y direction
	if (StringMatch(Direction,"Z"))
		SignValue *= -1
	elseif (IsClosedLoop)
		SignValue *= GV(Direction+"ScanDirection")
	endif
	
	Variable CurrentPos
	Variable Sens
	String LoopStr = ""
	if (IsClosedLoop)
		Sens = GV(Direction+"LVDTSens")  // sensitivity of LVDTSens, used to convert um to V
		CurrentPos = Td_ReadValue("$output"+Direction+"Loop.Setpoint")  // currently setpoint of LDVT  in PIDSLoop wave under outputXLoop column
	else
		Sens = GV(Direction+"PiezoSens")  // Open-loop sensitivity factor for the X-axis piezo (um/V)  nonlinear so not accurate outside of small movements
		CurrentPos = td_readValue("output."+Direction)  // piezo drive on X axis
	endif
	StepSize /= Sens  // converts stepsize into volts
	StepSize *= SignValue  // applies sign indicating correct direction ie. right or left
	
	
	String ErrorStr = ""
	
//	PV("NudgerInAction",0)
//	GhostNudger()
	String RampChannel = ""
	if (IsClosedLoop)  // again this checks if we are using LVDT or piezo to control motion
		RampChannel = "$output"+Direction+"Loop.Setpoint"
	else
		RampChannel = "output."+Direction
	endif
	ErrorStr += num2str(td_SetRamp(.1, RampChannel,0,CurrentPos+StepSize,"",0,0,"",0,0,""))+","  //this moves the tip.  I deleted NudgerCallbackFunction from the end of td_SetRamp
	ARReportError(ErrorStr)
	
	if (Isitchecked()==1)
		DataStorage()
	endif
	
	ControlUpdate /A /W=ControlledStep //updates all windows

End // End of function XStepLeft


Function DataCollection(ctrlname,checked)  // when box is checked a new wave is created in a folder named Run1, Run2, ...
	String ctrlName
	Variable checked  // 1 if selected 0 if not
	
	If(checked ==1)
		CreatesubDF()
	endif
End

